#######################################################################
#                    Order Form Definition Variables                  #
#######################################################################

%sc_order_form_array =('Ecom_BillTo_Postal_Name_First', 'First Name',
                       'Ecom_BillTo_Postal_Name_Last', 'Last Name',
                       'Ecom_BillTo_Postal_Street_Line1', 'Billing Address Street',
                       'Ecom_BillTo_Postal_City', 'Billing Address City',
                       'Ecom_BillTo_Postal_StateProv', 'Billing Address State',
                       'Ecom_BillTo_PostalCode', 'Billing Address Zip',
                       'Ecom_BillTo_Postal_CountryCode', 'Billing Address Country',
                       'Ecom_ShipTo_Postal_Street_Line1', 'Shipping Address Street',
                       'Ecom_ShipTo_Postal_City', 'Shipping Address City',
                       'Ecom_ShipTo_Postal_StateProv', 'Shipping Address State',
                       'Ecom_ShipTo_Postal_PostalCode', 'Shipping Address Zip',
                       'Ecom_ShipTo_Postal_CountryCode', 'Shipping Address Country',
                       'Ecom_BillTo_Telecom_Phone_Number', 'Phone Number',
                       'Ecom_BillTo_Online_Email', 'Email',
                       'Ecom_Payment_Card_Type', 'Type of Card',
                       'Ecom_Payment_Card_Number', 'Card Number',
                       'Ecom_Payment_Card_ExpDate_Month', 'Card Expiration Month',
                       'Ecom_Payment_Card_ExpDate_Day', 'Card Expiration Day',
                       'Ecom_Payment_Card_ExpDate_Year', 'Card Expiration Year');
                        

@sc_order_form_required_fields = ("Ecom_ShipTo_Postal_StateProv");

###############################################################################

sub printSubmitPage

{
local($invoice_number, $customer_number);

$invoice_number = time;
$customer_number = $cart_id;
$customer_number =~ s/_/./g;

print <<ENDOFTEXT;

<INPUT TYPE=HIDDEN NAME=\"storename\" VALUE=\"$sc_gateway_username\">
<INPUT TYPE=HIDDEN NAME=\"ordnum\" VALUE=\"$invoice_number\">
<INPUT TYPE=HIDDEN NAME=\"custnum\" VALUE=\"$customer_number\">

<TABLE WIDTH="500" BGCOLOR="#C0FFFF" CELLPADDING="0" CELLSPACING="0">
<TR>
<TD>

<CENTER>
<TABLE WIDTH="480" BGCOLOR="#000080" CELLPADDING="0" CELLSPACING="0">
<TR BGCOLOR="#C0FFFF">
<TD BGCOLOR="#C0FFFF"><FONT FACE="ARIAL" SIZE="2" COLOR="#000000">
<b>Please verify the information listed above. When you are confident 
that it is correct, click the 'Secure Orderform' button to enter 
your payment information</b></FONT></TD>
<TD  BGCOLOR="#C0FFFF">
</TR>
<TR BGCOLOR="#C0FFFF">
<TD>
<CENTER>
<INPUT TYPE=SUBMIT VALUE="Secure Orderform">
</CENTER>
</TD>
</TR>
</TABLE>
</CENTER>

</TD>
</TR>
</TABLE>

</CENTER>
</FORM>

ENDOFTEXT

}
############################################################################################

sub processOrder {

local($subtotal, $total_quantity,
      $total_measured_quantity,
      $text_of_cart,
      $required_fields_filled_in, $product, $quantity, $options);

$orderDate = &get_date;

print qq!
<HTML>
<HEAD>
<TITLE>Thank you for your order</TITLE>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
</HEAD>
</BODY>
!;

&StoreHeader;

$text_of_cart .= "New Order: $orderDate\n\n";

$text_of_cart .= "  --PRODUCT INFORMATION--\n\n";

open (CART, "$sc_cart_path") ||
&file_open_error("$sc_cart_path", "display_cart_contents", __FILE__, __LINE__);

while (<CART>)

{
$cartData++;
@cart_fields = split (/\|/, $_);
$quantity = $cart_fields[0];
$product_price = $cart_fields[3];
$product = $cart_fields[4];
$options = $cart_fields[7];
$options =~ s/<br>//g;
$text_of_cart .= "Quantity:      $quantity\nProduct:       $product $sc_money_symbol $product_price\n";
$text_of_cart .= "Options:       $options\n\n";
}

close(CART);

$text_of_confirm_email .= 
"Thank you for your order. We appreciate your business and will do 
everything we can to meet your expectations. Please visit us again soon!\n\n";

$text_of_confirm_email .= $text_of_cart;
$text_of_confirm_email .= "\n";
$text_of_cart .= "  --ORDER INFORMATION--\n\n";

$text_of_cart .= "CUSTID:        $form_data{'custnum'}\n";
$text_of_confirm_email .= "CUSTID:        $form_data{'custnum'}\n";

$text_of_cart .= "INVOICE:       $form_data{'oid'}\n\n";
$text_of_confirm_email .= "INVOICE:       $form_data{'oid'}\n\n";

$text_of_cart .= "STATUS:        $form_data{'status'}\n";
$text_of_cart .= "APPROVAL CODE: $form_data{'approval_code'}\n\n";

$text_of_cart .= "SUBTOTAL:      $form_data{'subtotalamount'}\n";
$text_of_confirm_email .= "SUBTOTAL:      $form_data{'subtotalamount'}\n";

if ($form_data{'shippingamount'})
{
$text_of_cart .= "SHIPPING:      $form_data{'shippingamount'} - $form_data{'shippingmethod'}\n";
$text_of_confirm_email .= "SHIPPING:      $form_data{'shippingamount'} - $form_data{'shippingmethod'}\n";
}

if ($form_data{'salestaxamount'})
{
$text_of_cart .= "SALES TAX:     $form_data{'salestaxamount'}\n";
$text_of_confirm_email .= "SALES TAX:     $form_data{'salestaxamount'}\n";
}

$text_of_cart .= "TOTAL:         $form_data{'chargetotal'}\n\n";
$text_of_confirm_email .= "TOTAL:         $form_data{'chargetotal'}\n\n";
$text_of_cart .= "BILLING INFORMATION --------------\n\n";
$text_of_cart .= "NAME:          $form_data{'bname'}\n";
$text_of_cart .= "ADDRESS1:      $form_data{'baddr1'}\n";
$text_of_cart .= "ADDRESS2:      $form_data{'baddr2'}\n";
$text_of_cart .= "STATE:         $form_data{'bstate'}\n";
$text_of_cart .= "PROVINCE       $form_data{'bstate2'}\n";
$text_of_cart .= "ZIP:           $form_data{'bzip'}\n";
$text_of_cart .= "COUNTRY:       $form_data{'bcountry'}\n";
$text_of_cart .= "PHONE:         $form_data{'phone'}\n";
$text_of_cart .= "FAX:           $form_data{'fax'}\n";
$text_of_cart .= "EMAIL:         $form_data{'email'}\n\n";
$text_of_cart .= "SHIPPING INFORMATION --------------\n\n";
$text_of_cart .= "NAME:          $form_data{'sname'}\n";
$text_of_cart .= "ADDRESS1:      $form_data{'saddr1'}\n";
$text_of_cart .= "ADDRESS2:      $form_data{'saddr2'}\n";
$text_of_cart .= "CITY:          $form_data{'scity'}\n";
$text_of_cart .= "STATE:         $form_data{'sstate'}\n";
$text_of_cart .= "PROVINCE       $form_data{'sstate2'}\n";
$text_of_cart .= "ZIP:           $form_data{'szip'}\n";
$text_of_cart .= "COUNTRY:       $form_data{'scountry'}\n\n";

if ($sc_use_pgp =~ /yes/i)
{
&require_supporting_libraries(__FILE__, __LINE__, "$sc_pgp_lib_path");
$text_of_cart = &make_pgp_file($text_of_cart, "$sc_pgp_temp_file_path/$$.pgp");
$text_of_cart = "\n" . $text_of_cart . "\n";
}

if ($sc_send_order_to_email =~ /yes/i)
{
&send_mail($sc_order_email, $sc_order_email, "Commerce.cgi Order",$text_of_cart);
}

if ($sc_send_order_to_log =~ /yes/i) {
open (ORDERLOG, "+>>./log_files/$sc_order_log_name");
print ORDERLOG "-" x 60 . "\n";
print ORDERLOG $text_of_cart;
print ORDERLOG "-" x 60 . "\n";
close (ORDERLOG);
}

if ($cartData)
{
&send_mail($sc_admin_email, $form_data{'email'}, "Thank you for your order!", "$text_of_confirm_email");
}
  
print <<ENDOFTEXT;
<CENTER>
<TABLE WIDTH=500>
<TR>
<TD WIDTH=500>
<BR>
<FONT FACE=ARIAL>
Thank you for shopping with us. Your order has been received and will be 
shipped as soon as possible. Please visit us again soon!<br>
<P>&nbsp;</P>
<a href=commerce.cgi>Return To Front Page</a>
<P>&nbsp;</P>
<P>&nbsp;</P>
</FONT>
</TD>
</TR>
</TABLE>
<CENTER>  

ENDOFTEXT

# This empties the cart after the order is successful

open (CART, ">$sc_cart_path");
close (CART);

# and the footer is printed

&StoreFooter;

print qq!
</BODY>
</HTML>
!;

} # End of process_order_form

#################################################################

sub display_calculations {

local($upgradeShipPrice, $shipMethod) = split (/\|/,$form_data{upgradeShipping});

local($subtotal,
      $are_we_before_or_at_process_form,
      $total_measured_quantity,
      $text_of_cart) = @_;

local($final_shipping,
	$final_discount,
	$final_sales_tax,$grand_total) =
	&calculate_final_values($subtotal,
	$total_quantity,
	$total_measured_quantity,
	$are_we_before_or_at_process_form);
 
if ($final_shipping > 0)
{
print "<TR>\n";
print "<TD>\n";

$final_shipping = &format_price($final_shipping);

$pass_final_shipping = $final_shipping;

$final_shipping = &display_price($final_shipping);

if($upgradeShipPrice && $shipMethod)
{
print "<CENTER>$cart_font_style $shipMethod: $final_shipping</FONT></CENTER>\n";
}
else
{
print "<CENTER>$cart_font_style Shipping: $final_shipping</FONT></CENTER>\n";
}
print "</TD>\n";
print "</TR>\n";

if($upgradeShipPrice && $shipMethod)
{
$final_shipping += ($final_shipping*($shipPrice/100));

$final_shipping = &format_price($final_shipping);

$final_shipping = &display_price($final_shipping);

$text_of_cart .= &format_text_field("$shipMethod:") . 
"= $final_shipping\n\n";
}
else
{
$final_shipping = &format_price($final_shipping);

$final_shipping = &display_price($final_shipping);

$text_of_cart .= &format_text_field("Shipping:") . 
"= $final_shipping\n\n";
}

};

if ($final_discount > 0)
{
$final_discount = &format_price($final_discount);

$pass_final_discount = &format_price($final_discount);

$final_discount = &display_price($final_discount);

print "<TR>\n";
print "<TD>\n";
print "<CENTER>$cart_font_style Discount: $final_discount</FONT></CENTER>\n";
print "</TD>\n";
print "</TR>\n";

$text_of_cart .= &format_text_field("Discount:") . 
"= $final_discount\n\n";
}

if ($final_sales_tax > 0)
{
$final_sales_tax = &format_price($final_sales_tax);

$pass_final_sales_tax = &format_price($final_sales_tax);

$final_sales_tax = &display_price($final_sales_tax);

print "<TR>\n";
print "<TD>\n";
print "<CENTER>$cart_font_style Sales Tax: $final_sales_tax</FONT></CENTER>\n";
print "</TD>\n";
print "</TR>\n";

$text_of_cart .= &format_text_field("Sales Tax:") . 
"= $final_sales_tax\n\n";
}

$authPrice = $grand_total;
$grand_total = &display_price($grand_total);

print "<TR>\n";
print "<TD>\n";
print "<CENTER>$cart_font_style Grand Total: $grand_total</FONT></CENTER><P>\n";
print "</TD>\n";
print "</TR>\n";
print "</TABLE>\n";

if ($are_we_before_or_at_process_form =~ /at/i) 
{
print <<ENDOFTEXT;

</FORM>

<FORM METHOD=POST ACTION=\"$sc_order_script_url\">
<INPUT TYPE=HIDDEN NAME=\"chargetotal\" VALUE=\"$authPrice\">
<INPUT TYPE=HIDDEN NAME="mode" value="fullpay">

<INPUT TYPE=HIDDEN NAME=\"shippingamount\" VALUE=\"$pass_final_shipping\">
<INPUT TYPE=HIDDEN NAME=\"salestaxamount\" VALUE=\"$pass_final_sales_tax\">

<INPUT TYPE=HIDDEN NAME=\"shipping\" VALUE=\"$pass_final_shipping\">
<INPUT TYPE=HIDDEN NAME=\"tax\" VALUE=\"$pass_final_sales_tax\">
<INPUT TYPE=HIDDEN NAME=\"subtotal\" VALUE=\"$subtotal\">

<INPUT TYPE=HIDDEN NAME=\"shippingmethod\" VALUE=\"$shipMethod\">
<INPUT TYPE=HIDDEN NAME=\"subtotalamount\" VALUE=\"$subtotal\">

ENDOFTEXT
}

$text_of_cart .= &format_text_field("Grand Total:") . 
"= $grand_total\n\n";

return ($text_of_cart);

}
